#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseX64=Y
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/so
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#pragma compile(x64, true)
;~ #pragma compile(x64, false);true, false
#include <Misc.au3>
#include <WinAPI.au3>
#include <GDIPlus.au3>
#include <ScreenCapture.au3>
;Opt("MustDeclareVars", 1)

#include "ImageSearch_UDF.au3"

HotKeySet("{Esc}", "_Exit")

_ImageSearch_Example()

Func _ImageSearch_Example()
	; At first. You have to create 2 file Seach.bmp and Seach_Me.bmp of your screen (i.e some icon)
	;==> create Image for Search
	Local $IMGDir = @ScriptDir
	Local $_Image_1 = $IMGDir & "\Search_1.bmp"
	Local $_Image_2 = $IMGDir & "\Search_2.bmp"

	If Not FileExists($_Image_1) Or Not FileExists($_Image_2) Then
		MsgBox(64, 'ImageSearch', 'At first, use this function to create 2 file bmp, maybe a desktop icon for example', 60)
		_ImageSearch_Create_BMP($_Image_1)
		_ImageSearch_Create_BMP($_Image_2)
	EndIf

	;==>Example 0 - Return Position Center
	MsgBox(0, 'Example 1', 'Check if an Image appear on your screen', 1)
	Local $return = _ImageSearch($_Image_2)
	If $return[0] > 0 Then
		MouseMove($return[1], $return[2])
		MsgBox(0, 'Eg 1 - Success', 'Image found:' & " X=" & $return[1] & " Y=" & $return[2] & @CRLF & $_Image_2, 1)
	Else
		MsgBox(48, 'Eg 1 - Failed', 'Image not found', 2)
	EndIf

	Sleep(1000)
	Local $find_ListImage = $_Image_1 & '|' & $_Image_2
	;==>Example 2
	MsgBox(0, 'Example 2', 'Check an of list image appear on your screen. Move mouse to it', 1)
	Local $return = _ImageSearch_Area($find_ListImage, 0, 0, 0, 0, 0, -1, 99, 1, 1, 1.0, 1.0, 1.0, True)
	If $return[0][0] > 0 Then
		MsgBox(0, 'Eg 2 - Success', 'Image found:' & $find_ListImage, 2)
		If $return[0][0] > 1 Then
			For $I = 1 To $return[0][0]
				MouseMove($return[$I][1], $return[$I][2])
				Sleep(1000)
			Next
		Else
			MouseMove($return[1][1], $return[2][1])
		EndIf
	Else
		MsgBox(48, 'Eg 2 - Failed', 'Image not found', 2)
	EndIf

EndFunc   ;==>_ImageSearch_Example

; * -----:| Dao Van Trong - TRONG.PRO

; Thanks for Melba23 about rectangle example
Func _ImageSearch_Create_BMP($Filename)
	Local $aMouse_Pos, $hMask, $hMaster_Mask, $iTemp
	Local $UserDLL = DllOpen("user32.dll")

	; Create transparent GUI with Cross cursor
	Local $hCross_GUI = GUICreate("", @DesktopWidth, @DesktopHeight, 0, 0, 0x80000000, BitAND(0x00000080, 0x00000008))
	WinSetTrans($hCross_GUI, "", 8)
	GUISetState(@SW_SHOW, $hCross_GUI)
	GUISetCursor(3, 1, $hCross_GUI)

	Local $hRectangle_GUI = GUICreate("", @DesktopWidth, @DesktopHeight, 0, 0, 0x80000000, BitAND(0x00000080, 0x00000008))
	GUISetBkColor(0x000000)

	; Wait until mouse button pressed
	While Not _IsPressed("01", $UserDLL)
		If _IsPressed("1B", $UserDLL) Then
			GUIDelete($hRectangle_GUI)
			GUIDelete($hCross_GUI)
			DllClose($UserDLL)
			Return -2
		EndIf

		Sleep(10)
	WEnd

	; Get first mouse position
	Local $aMouse_Pos = MouseGetPos()
	Local $iX1 = $aMouse_Pos[0]
	Local $iY1 = $aMouse_Pos[1]
	; Draw rectangle while mouse button pressed
	While _IsPressed("01", $UserDLL)

		$aMouse_Pos = MouseGetPos()

		$hMaster_Mask = _WinAPI_CreateRectRgn(0, 0, 0, 0)
		$hMask = _WinAPI_CreateRectRgn($iX1, $aMouse_Pos[1], $aMouse_Pos[0], $aMouse_Pos[1] + 1) ; Bottom of rectangle
		_WinAPI_CombineRgn($hMaster_Mask, $hMask, $hMaster_Mask, 2)
		_WinAPI_DeleteObject($hMask)
		$hMask = _WinAPI_CreateRectRgn($iX1, $iY1, $iX1 + 1, $aMouse_Pos[1]) ; Left of rectangle
		_WinAPI_CombineRgn($hMaster_Mask, $hMask, $hMaster_Mask, 2)
		_WinAPI_DeleteObject($hMask)
		$hMask = _WinAPI_CreateRectRgn($iX1 + 1, $iY1 + 1, $aMouse_Pos[0], $iY1) ; Top of rectangle
		_WinAPI_CombineRgn($hMaster_Mask, $hMask, $hMaster_Mask, 2)
		_WinAPI_DeleteObject($hMask)
		$hMask = _WinAPI_CreateRectRgn($aMouse_Pos[0], $iY1, $aMouse_Pos[0] + 1, $aMouse_Pos[1]) ; Right of rectangle
		_WinAPI_CombineRgn($hMaster_Mask, $hMask, $hMaster_Mask, 2)
		_WinAPI_DeleteObject($hMask)
		; Set overall region
		_WinAPI_SetWindowRgn($hRectangle_GUI, $hMaster_Mask)

		If WinGetState($hRectangle_GUI) < 15 Then GUISetState()
		Sleep(10)

	WEnd

	; Get second mouse position
	Local $iX2 = $aMouse_Pos[0]
	Local $iY2 = $aMouse_Pos[1]

	; Set in correct order if required
	If $iX2 < $iX1 Then
		$iTemp = $iX1
		$iX1 = $iX2
		$iX2 = $iTemp
	EndIf
	If $iY2 < $iY1 Then
		$iTemp = $iY1
		$iY1 = $iY2
		$iY2 = $iTemp
	EndIf
	GUIDelete($hRectangle_GUI)
	GUIDelete($hCross_GUI)
	DllClose($UserDLL)
	Local $mouse = MouseGetPos() ; remove mouse to other
	MouseMove($mouse[0] + 10, $mouse[1] + 10)
	Sleep(1000)
	_GDIPlus_Startup()
	Local $hHBitmap = _ScreenCapture_Capture("", $iX1, $iY1, $iX2, $iY2)
	Local $hImage1 = _GDIPlus_BitmapCreateFromHBITMAP($hHBitmap)
	_GDIPlus_ImageSaveToFile($hImage1, $Filename)
	_GDIPlus_Shutdown()
;~ 	$hHBitmap = _ScreenCapture_Capture("test3.bmp", $iX1, $iY1, $iX2, $iY2)
EndFunc   ;==>_ImageSearch_Create_BMP

Func _Exit()
	Exit 0
EndFunc   ;==>_Exit
